#ifndef PUSHBUTTONHPP
#define PUSHBUTTONHPP

#include <string.h>

#include "icon.hpp"
#include "box.hpp"
#include "limit.hpp"
#include "graphics.hpp"
#include "legend.hpp"

#define PUSH_BUTTON_WIDTH 70
#define PUSH_BUTTON_HEIGHT 30

class PushButton: public Icon {

protected:

	char legend [MAX_LEGEND_LENGTH + 1];
	int *state;
	void (*activation_function)();
	ShadedBox* box;

	COLOR_TYPE shade_color;
	COLOR_TYPE border_color;
	COLOR_TYPE fill_color;
	COLOR_TYPE inactive_color;
	COLOR_TYPE active_color;
	COLOR_TYPE legend_color;

public:

	PushButton(int, int, char*, int*, void(*)() );
	int CurrentState() {return *state;}
	void SetLegend(char* string) 
	  {strncpy(legend, string, sizeof(legend) );}
	virtual void Update() {}
	virtual void LeftButtonPressed() {}
	virtual void LeftButtonReleased() {}
	virtual void Display();
	void Activate();
	virtual ~PushButton();
};

class BistablePushButton: public PushButton {

public:

	BistablePushButton(int, int, char*, int*, void (*)() );
	virtual void Update() {}
	void LeftButtonPressed();
};

class MonostablePushButton: public PushButton {

public:

	MonostablePushButton(int, int, char*, int*, void (*)() );
	virtual void Update() {}
	void LeftButtonPressed();
	void LeftButtonReleased();
};

#endif
